--Function is ran only once.
function love.load()
	ScrWidth = love.graphics.getWidth()
	ScrHeight = love.graphics.getHeight()
	EnteredValue = ""
	CurrencyValue = 0
	ConvertedValue = 0
	ConvertFrom = "None"
	ConvertTo = "None"
	DisplayTrueValue = false
	
	
	--Stores the $ to currency rates
	ConversionRate = {Pound = 0.64, Francs = 0.607426, Lire = 1793.62, Mark = 1.811, Pesetas = 154.076,Dollar = 1}
	--Stores data for each button that will be drawn on the screen. (Allows easy modifying of the data)
	Button = {Calculate = {},Clear = {},Exit = {},DisplayValue = {},EnterValue = {},ConversionDisplay = {},Pound = {},Francs = {},Lire = {},Mark = {},Pesetas = {},Dollar = {}}
	
	Button.DisplayValue = {PosX = 20,PosY = ScrHeight - 165,SizeX = ScrWidth-40,SizeY = 30,Text = "No Conversion Made",CallBack = function() end}
	
	--Format: Position X, Position Y, Size X, Size Y, Desired Text, Function if button is pressed.
	Button.Calculate = {PosX = 0,PosY = ScrHeight - 130,SizeX = ScrWidth,SizeY = 40,Text = "Calculate",CallBack = function() 
	print(ConvertFrom,ConvertTo,CurrencyValue)
		if ConvertFrom ~= "None" and ConvertTo ~= "None" then
			if ConvertFrom == "Dollar" then
				local Result = CurrencyValue * ConversionRate[ConvertTo]
				--Displays up to 8 decimal places.
				local ConvertedValue = math.floor(Result*(10^8) + 0.5)/(10^8)
				Button.DisplayValue.Text = CurrencyValue .. " " .. ConvertFrom .. " is " .. ConvertedValue .. " " .. ConvertTo
			else
				--Converts to dollars then to proper currency
				local Result = (CurrencyValue / ConversionRate[ConvertFrom]) * ConversionRate[ConvertTo]
				local ConvertedValue = math.floor(Result*(10^8) + 0.5)/(10^8)
				Button.DisplayValue.Text = CurrencyValue .. " " .. ConvertFrom .. " is " .. ConvertedValue .. " " .. ConvertTo
			end
		end
	end}
	
	Button.Clear = {PosX = 0,PosY = ScrHeight - 85,SizeX = ScrWidth,SizeY = 40,Text = "Clear",CallBack = function()
		ConvertFrom = "None"
		ConvertTo = "None"
		CurrencyValue = 0
		ConvertedValue = 0
		EnteredValue = ""
		DisplayTrueValue = false
		Button.DisplayValue.Text = "No Conversion Made"
	end}
	
	Button.ConversionDisplay = {PosX = 545,PosY = 5,SizeX = ScrWidth-545,SizeY = 50,Text = ConvertFrom .. " to " .. ConvertTo,CallBack = function() end}
	
	Button.EnterValue = {PosX = 20,PosY = ScrHeight - 200,SizeX = ScrWidth-40,SizeY = 30,Text = "",CallBack = function() end}
	
	Button.Exit = {PosX = 0,PosY = ScrHeight - 40,SizeX = ScrWidth,SizeY = 40,Text = "Exit",CallBack = function()
		love.event.quit()
	end}
	
	Button.Pound = {PosX = 5,PosY = 5,SizeX = 80,SizeY = 50,Text = "Pound",CallBack = function()
		if ConvertFrom == "None" then
			ConvertFrom = "Pound"
		elseif ConvertTo == "None" then
			ConvertTo = "Pound"
		end
	end}
	
	Button.Francs = {PosX = 95,PosY = 5,SizeX = 80,SizeY = 50,Text = "Francs",CallBack = function()
		if ConvertFrom == "None" then
			ConvertFrom = "Francs"
		elseif ConvertTo == "None" then
			ConvertTo = "Francs"
		end
	end}
	
	Button.Lire = {PosX = 185,PosY = 5,SizeX = 80,SizeY = 50,Text = "Lire",CallBack = function()
		if ConvertFrom == "None" then
			ConvertFrom = "Lire"
		elseif ConvertTo == "None" then
			ConvertTo = "Lire"
		end
	end}
	
	Button.Mark = {PosX = 275,PosY = 5,SizeX = 80,SizeY = 50,Text = "Mark",CallBack = function()
		if ConvertFrom == "None" then
			ConvertFrom = "Mark"
		elseif ConvertTo == "None" then
			ConvertTo = "Mark"
		end
	end}
	
	Button.Pesetas = {PosX = 365,PosY = 5,SizeX = 80,SizeY = 50,Text = "Pesetas",CallBack = function()
		if ConvertFrom == "None" then
			ConvertFrom = "Pesetas"
		elseif ConvertTo == "None" then
			ConvertTo = "Pesetas"
		end
	end}
	
	Button.Dollar = {PosX = 455,PosY = 5,SizeX = 80,SizeY = 50,Text = "Dollar",CallBack = function()
		if ConvertFrom == "None" then
			ConvertFrom = "Dollar"
		elseif ConvertTo == "None" then
			ConvertTo = "Dollar"
		end
	end}
	
	--Checks if button is pressed whenever a click occurs and executes callback functions
	function CheckButtonPress(MouseX,MouseY)
		for i,v in pairs(Button) do
			if MouseX >= v.PosX and MouseX <= v.PosX + v.SizeX and MouseY >= v.PosY and MouseY <= v.PosY + v.SizeY then
				v.CallBack()
			end
		end
	end
end

--Detects mouse button presses.
function love.mousepressed( x, y, button)
	if button == "l" then
		CheckButtonPress(x,y)
	end
end

--Detects keyboard button presses
function love.keypressed(key)
	print(key)
	if key:match("%d") or key == "." and not EnteredValue:find(".",1,true) then
		EnteredValue = EnteredValue .. key
	elseif key == "backspace" then
		EnteredValue = EnteredValue:sub(1,EnteredValue:len()-1)
	elseif key == "enter" or key == "return" then
		if tonumber(EnteredValue) then
			CurrencyValue = tonumber(EnteredValue)
			DisplayTrueValue = true
			Button.DisplayValue.Text = "Will convert " .. CurrencyValue
		end
	end
	Button.EnterValue.Text = EnteredValue
end

--Draws to screen every frame.
function love.draw()
	font = love.graphics.newFont(14)
	love.graphics.setFont(font)
	--Calculate Button
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.Calculate.PosX,Button.Calculate.PosY,Button.Calculate.SizeX,Button.Calculate.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.Calculate.Text,(Button.Calculate.PosX + Button.Calculate.SizeX/2)-font:getWidth(Button.Calculate.Text)/2,(Button.Calculate.PosY + Button.Calculate.SizeY/2)-font:getHeight(Button.Calculate.Text)/2)
	
	--Clear Button--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.Clear.PosX,Button.Clear.PosY,Button.Clear.SizeX,Button.Clear.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.Clear.Text,(Button.Clear.PosX + Button.Clear.SizeX/2)-font:getWidth(Button.Clear.Text)/2,(Button.Clear.PosY + Button.Clear.SizeY/2)-font:getHeight(Button.Clear.Text)/2)
	
	--Exit Button--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.Exit.PosX,Button.Exit.PosY,Button.Exit.SizeX,Button.Exit.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.Exit.Text,(Button.Exit.PosX + Button.Exit.SizeX/2)-font:getWidth(Button.Exit.Text)/2,(Button.Exit.PosY + Button.Exit.SizeY/2)-font:getHeight(Button.Exit.Text)/2)
	
	--DisplayValue Text--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.DisplayValue.PosX,Button.DisplayValue.PosY,Button.DisplayValue.SizeX,Button.DisplayValue.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.DisplayValue.Text,(Button.DisplayValue.PosX + Button.DisplayValue.SizeX/2)-font:getWidth(Button.DisplayValue.Text)/2,(Button.DisplayValue.PosY + Button.DisplayValue.SizeY/2)-font:getHeight(Button.DisplayValue.Text)/2)
	
	--EnterValue--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.EnterValue.PosX,Button.EnterValue.PosY,Button.EnterValue.SizeX,Button.EnterValue.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.EnterValue.Text,(Button.EnterValue.PosX + Button.EnterValue.SizeX/2)-font:getWidth(Button.EnterValue.Text)/2,(Button.EnterValue.PosY + Button.EnterValue.SizeY/2)-font:getHeight(Button.EnterValue.Text)/2)
	
	--Pounds Button--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.Pound.PosX,Button.Pound.PosY,Button.Pound.SizeX,Button.Pound.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.Pound.Text,(Button.Pound.PosX + Button.Pound.SizeX/2)-font:getWidth(Button.Pound.Text)/2,(Button.Pound.PosY + Button.Pound.SizeY/2)-font:getHeight(Button.Pound.Text)/2)
	
	--Francs Button
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.Francs.PosX,Button.Francs.PosY,Button.Francs.SizeX,Button.Francs.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.Francs.Text,(Button.Francs.PosX + Button.Francs.SizeX/2)-font:getWidth(Button.Francs.Text)/2,(Button.Francs.PosY + Button.Francs.SizeY/2)-font:getHeight(Button.Francs.Text)/2)
	
	--Lire Button--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.Lire.PosX,Button.Lire.PosY,Button.Lire.SizeX,Button.Lire.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.Lire.Text,(Button.Lire.PosX + Button.Lire.SizeX/2)-font:getWidth(Button.Lire.Text)/2,(Button.Lire.PosY + Button.Lire.SizeY/2)-font:getHeight(Button.Lire.Text)/2)
	
	--Mark Button--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.Mark.PosX,Button.Mark.PosY,Button.Mark.SizeX,Button.Mark.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.Mark.Text,(Button.Mark.PosX + Button.Mark.SizeX/2)-font:getWidth(Button.Mark.Text)/2,(Button.Mark.PosY + Button.Mark.SizeY/2)-font:getHeight(Button.Mark.Text)/2)
	
	--Pesetas Button--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.Pesetas.PosX,Button.Pesetas.PosY,Button.Pesetas.SizeX,Button.Pesetas.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.Pesetas.Text,(Button.Pesetas.PosX + Button.Pesetas.SizeX/2)-font:getWidth(Button.Pesetas.Text)/2,(Button.Pesetas.PosY + Button.Pesetas.SizeY/2)-font:getHeight(Button.Pesetas.Text)/2)
	
	--Dollar Button--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.Dollar.PosX,Button.Dollar.PosY,Button.Dollar.SizeX,Button.Dollar.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(Button.Dollar.Text,(Button.Dollar.PosX + Button.Dollar.SizeX/2)-font:getWidth(Button.Dollar.Text)/2,(Button.Dollar.PosY + Button.Dollar.SizeY/2)-font:getHeight(Button.Dollar.Text)/2)
	
	--ConversionDisplay--
	love.graphics.setColor(83,185,210)
	love.graphics.rectangle("fill",Button.ConversionDisplay.PosX,Button.ConversionDisplay.PosY,Button.ConversionDisplay.SizeX,Button.ConversionDisplay.SizeY)
	love.graphics.setColor(255,255,255)
	love.graphics.print(ConvertFrom .. " to " .. ConvertTo,(Button.ConversionDisplay.PosX + Button.ConversionDisplay.SizeX/2)-font:getWidth(Button.ConversionDisplay.Text)/2,(Button.ConversionDisplay.PosY + Button.ConversionDisplay.SizeY/2)-font:getHeight(Button.ConversionDisplay.Text)/2)
end


